               /*Ŀ
                                                                        
                               CHARACTER WRITING FUNCTIONS              
                                                                        
                               write horizontal normal, big,            
                               and video characters and strings         
                               and vertical characters and strings.     
                                                                        
                 */

#include "gdraws.h"
#include "chars.h"

void write_horz_char(int x, int y, int ch, int color)
{
	int offset,i,j;
	unsigned char char_test;

        x = ((x + 319)*18) >> 4;
	y = 174 - ((93*y) >> 7);		
	offset = (ch - 32) * 14;
	for (i=0; i<14; i++)
	{
		for (j=0; j<8; j++)
		{
			char_test = 0x80 >> j;
		        if ((char_table[offset+i] & char_test) != 0)
			{
				if (color == 1)
					plot(x+j,y+i,1);
				else
					plot(x+j,y+i,0);
			}
			else
			{
				if (color == 1)
					plot(x+j,y+i,0);
				else
					plot(x+j,y+i,1);
			}
		}
		if (color == 1)
			plot(x+j,y+i,0);
		else
			plot(x+j,y+i,1);
	}
}

void write_vert_char(int x, int y, int ch, int color)
{
	int offset,i,j;
	unsigned char char_test;

	x = ((x + 319)*18) >> 4;
	y = 174 - ((93*y) >> 7);		
	offset = (ch - 32) * 14;
	for (i=0; i<14; i++)
	{
		for (j=0; j<8; j++)
		{
			char_test = 0x80 >> j;
		        if ((char_table[offset+i] & char_test) != 0)
			{
				if (color == 1)
					plot(x+i,y-j,1);
				else
					plot(x+i,y-j,0);
			}
			else
			{
				if (color == 1)
					plot(x+i,y-j,0);
				else
					plot(x+i,y-j,1);
			}
		}
	}
}

void write_horz_str(int x, int y, char *string, int color)
{
	int p=0;

	while (string[p])
	{
		write_horz_char(x,y,string[p++],color);
		x += 8;
		if (x>312)
		{
			x=-319;
			y += 20;
		}
	}
}

void write_vert_str(int x, int y, char *string, int color)
{
	int p=0;

	while (string[p])
	{
		write_vert_char(x,y,string[p++],color);
		y += 12;
		if (y>228)
		{
			y=-239;
			x += 14;
		}
	}
}
void write_big_char(int x, int y, int ch, int color)
{
	int offset,i,j,k,m;
	unsigned char char_test;

        x = ((x + 319)*18) >> 4;
	y = 174 - ((93*y) >> 7);		
	offset = (ch - 32) * 14;
	for (i=0; i<14; i++)
	{
		for (j=0; j<8; j++)
		{
			char_test = 0x80 >> j;
			for(k=0; k<4; k++)
			{
				for(m=0; m<4; m++)
				{
				        if ((char_table[offset+i] &
						char_test) != 0)
					{
						if (color == 1)
							plot(x+4*j+m,
								y+4*i+k,1);
						else
							plot(x+4*j+m,
								y+4*i+k,0);
					}
					else
					{
						if (color == 1)
							plot(x+4*j+m,
								y+4*i+k,0);
						else
							plot(x+4*j+m,
								y+4*i+k,1);
					}
				}
			}
		}
	}
}

void write_vid_char(int x, int y, int ch, int color)
{
	int offset,i,j,k,m;
	unsigned char char_test;

        x = ((x + 319)*18) >> 4;
	y = 174 - ((93*y) >> 7);		
	offset = (ch - 32) * 14;
	for (i=0; i<14; i++)
	{
		for (j=0; j<8; j++)
		{
			char_test = 0x80 >> j;
			for(k=1; k<4; k++)
			{
				for(m=1; m<4; m++)
				{
				        if ((char_table[offset+i] &
						char_test) != 0)
					{
						if (color == 1)
							plot(x+4*j+m,
								y+4*i+k,1);
						else
							plot(x+4*j+m,
								y+4*i+k,0);
					}
					else
					{
						if (color == 1)
							plot(x+4*j+m,
								y+4*i+k,0);
						else
							plot(x+4*j+m,
								y+4*i+k,1);
					}
				}
			}
		}
	}
}

void write_big_str(int x, int y, char *string, int color)
{
	int p=0;

	while (string[p])
	{
		write_big_char(x,y,string[p++],color);
		x += 32;
		if (x>287)
		{
			x=-329;
			y -= 14;
		}
	}
}

void write_vid_str(int x, int y, char *string, int color)
{
	int p=0;

	while (string[p])
	{
		write_vid_char(x,y,string[p++],color);
		x += 32;
		if (x>287)
		{
			x=-319;
			y -= 14;
		}
	}
}

