               /*Ŀ
                                                                        
                  pattern_plot() = plots points alternating between     
                                   two colors according to a specified  
                                   pattern.                             
                                                                        
                 */

#include "gdraws.h"

void pattern_plot(int x, int y, int color)
{
	#include <dos.h>

	unsigned int mask, pattern[4][8];
	int i,foreground,background,fill;

	for (i=0; i<8; i++)
	{
		pattern[0][i] = 0xFFFF;
		if (i%2 == 0)
		{
			pattern[2][i] = 0x4444;
			pattern[3][i] = 0xAAAA;
                }
		else
		{
			pattern[2][i] = 0x1111;
			pattern[3][i] = 0x5555;
		}
	}
        pattern[1][0] = 0x2020;
        pattern[1][1] = 0x0202;
        pattern[1][2] = 0x8080;
        pattern[1][3] = 0x0808;
        pattern[1][4] = 0x2020;
        pattern[1][5] = 0x0202;
        pattern[1][6] = 0x8080;
        pattern[1][7] = 0x0808;
	foreground = color & 0x0F;
	background = (color & 0xF0) >> 4;
	fill = (color & 0xF00) >> 8;
	mask = 0x8000 >> (x % 16);
	if (pattern[fill][y%8] & mask)
		plot(x,y,foreground);
	else					
		plot(x,y,background);
}