               /*Ŀ
                                                                        
                  rotatePoly() = rotates a polygon whose sides and      
                                 color are specified through an         
                                 angle 'ANGLE' and draws polygon.       
                                                                        
                 */

#include <math.h>
#include "gdraws.h"

extern int XCENTER, YCENTER, ANGLE;

void rotatePoly(int color,...)
{
	#include <stdarg.h>
	#include <stdio.h>

	va_list coord;
        int point[600],i=0,j,x1,y1,x2,y2;
	float angle,param;

	va_start(coord,color);
	angle = .01745329*(360 - ANGLE);
	while (((point[i]=va_arg(coord,int)) >= -320) && (i<=600))
		i++;
	va_end(coord);
	point[i++] = point[0];
	point[i] = point[1];
	if (i<=5) return;
	for (j=0; j<i-2; j+=2)
	{
		x1 = (point[j] - XCENTER)*cos(angle) - (point[j+1] -
			YCENTER)*sin(angle) + XCENTER;
	       	y1 = (point[j] - XCENTER)*sin(angle) + (point[j+1] -
	       		YCENTER)*cos(angle) + YCENTER;
		x2 = (point[j+2] - XCENTER)*cos(angle) - (point[j+3] -
			YCENTER)*sin(angle) + XCENTER;
	        y2 = (point[j+2] - XCENTER)*sin(angle) + (point[j+3] -
        		YCENTER)*cos(angle) + YCENTER;
		drawLine(x1,y1,x2,y2,color);
	}
}	
