

               /*Ŀ
                                                                        
                    rotateRect() = draws a rectangle with top left and  
                                 bottom right corners specified in      
                                 specified color and rotated to a       
                                 specified angle.                       
                                                                        
                 */

#include <math.h>
#include "gdraws.h"


void rotateRect(int x1, int y1, int x2, int y2, int color)
{
	#include <dos.h>

	union REGS reg;

	int nx1,nx2,nx3,nx4,ny1,ny2,ny3,ny4;
        float angle;

	angle = .01745329*(360 - ANGLE);
	nx1 = (x1 - XCENTER)*cos(angle) - (y1 - YCENTER)*sin(angle)
		+ XCENTER;
        ny1 = (x1 - XCENTER)*sin(angle) + (y1 - YCENTER)*cos(angle)
        	+ YCENTER;
	nx3 = (x2 - XCENTER)*cos(angle) - (y2 - YCENTER)*sin(angle)
		+ XCENTER;
        ny3 = (x2 - XCENTER)*sin(angle) + (y2 - YCENTER)*cos(angle)
         	+ YCENTER;
	nx2 = (x2 - XCENTER)*cos(angle) - (y1 - YCENTER)*sin(angle)
		+ XCENTER;
        ny2 = (x2 - XCENTER)*sin(angle) + (y1 - YCENTER)*cos(angle)
        	+ YCENTER;
	nx4 = (x1 - XCENTER)*cos(angle) - (y2 - YCENTER)*sin(angle)
		+ XCENTER;
        ny4 = (x1 - XCENTER)*sin(angle) + (y2 - YCENTER)*cos(angle)
        	+ YCENTER;

        drawLine(nx1-LINEWIDTH/2,ny1,nx2+LINEWIDTH/2,ny2,color);
        drawLine(nx2-LINEWIDTH/2,ny2,nx3+LINEWIDTH/2,ny3,color);
        drawLine(nx3,ny3+LINEWIDTH/2,nx4,ny4-LINEWIDTH/2,color);
        drawLine(nx4,ny4+LINEWIDTH/2,nx1,ny1-LINEWIDTH/2,color);
}
