               /*Ŀ
                                                                        
                  drawOval() = draws an oval with specified center,     
                               radius, color and aspect ratio.          
                                                                        
                 */

#include "gdraws.h"



void drawOval(int x, int y, int b, int color, float aspect)
{
	#include <dos.h>

	union REGS reg;

	int col, i, row, bnew;
        float aspect_square;
	long a_square, b_square, two_a_square, two_b_square, four_a_square,
             four_b_square,d;

	aspect_square = aspect*aspect;
	b -= LINEWIDTH/2;
	for (i=1; i<=LINEWIDTH; i++)
	{
		b_square = b*b;
		a_square = (b*b)/aspect_square;
		row = b;
		col = 0;
		two_a_square = a_square << 1;
		four_a_square = a_square << 2;
		four_b_square = b_square << 2;
		two_b_square = b_square << 1;
		d = two_a_square * ((row  -1)*(row )) + a_square +
		    two_b_square*(1-a_square);
		while (a_square*(row ) > b_square * (col))
		{
			plots(col+x,row+y,color);
			plots(col+x,y-row, color);
			plots(x-col,row+y,color);
			plots(x-col,y-row,color);
			if (d>= 0)
			{
				row--;
				d -= four_a_square*(row);
			}
			d += two_b_square*(3 + (col << 1));
			col++;
		}
        	
		d = two_b_square * (col + 1)*col + two_a_square*(row *
        	        (row  -2) +1) + (1-two_a_square)*b_square;
		while ((row) + 1)
		{
			plots(col+x,row+y,color);
		        plots(col+x,y-row, color);
			plots(x-col,row+y,color);
			plots(x-col,y-row,color);
			if (d<= 0)
			{
				col++;
				d += four_b_square*col;
			}
			row--;
			d += two_a_square * (3 - (row <<1));
		}       	
		b++;
	}
}
