               /*Ŀ
                                                                        
                  fil2Poly() = fills a polygon in specified color by    
                               filling in boundaries resulting from     
                               connecting specified points in the       
                               order given and then connecting last     
                               point to first.  Uses an array to        
                               store coordinates.                       
                                                                        
                 */

#include "gdraws.h"

void fill2Poly(int color,int point[600])
{

	#define sign(x) ((x) > 0 ? 1:  ((x) == 0 ? 0:  (-1)))

	int dx, dy, dxabs, dyabs, i, index=0, j, k, px, py, sdx, sdy, x, y,
        	  toggle, old_sdy, sy0;
	int *x_coord, *y_coord, *n_point;

	x_coord = (int *) malloc(4000 * sizeof(int));
	y_coord = (int *) malloc(4000 * sizeof(int));
	n_point = (int *) malloc(600 * sizeof(int));
	for (i=0; i<=600; i+=2)
	{
		if ((point[i] < -320) || (point[i+1] < -320))
			break;
		n_point[i] = (point[i] + 319)*18 >> 4;
		n_point[i+1] = 174 - ((point[i+1]*93) >> 7);
	}
	n_point[i] = n_point[0];
	n_point[i+1] = n_point[1];
	if (i<=5) return;
	px = n_point[0];
	py = n_point[1];
	if (n_point[1] == n_point[3])
	{
		x_coord[index] = px;
		y_coord[index++] = py;
	}
	for (j=0; j<i-2; j+=2)
	{
		dx = n_point[j+2] - n_point[j];
		dy = n_point[j+3] - n_point[j+1];
		sdx = sign(dx);
		sdy = sign(dy);
		if (j==0)
		{
			old_sdy = sdy;
			sy0 = sdy;
		}
		dxabs = abs(dx);
		dyabs = abs(dy);
		x = 0;
		y = 0;
		if (dxabs >= dyabs)
		{
			for (k=0; k<dxabs; k++)
			{
				y += dyabs;
				if (y>=dxabs)
				{
					y -= dxabs;
					py += sdy;
					if (old_sdy != sdy)
					{
						old_sdy = sdy;
                        	                index--;
					}
					x_coord[index] = px+sdx;
					y_coord[index++] = py;
				}
				px += sdx;
				plot(px,py,color);
			}
		}
		else
		{
			for (k=0; k<dyabs; k++)
			{
				x += dxabs;
				if (x>=dyabs)
				{
					x -= dyabs;
					px += sdx;
	        		}

				py += sdy;
				if (old_sdy != sdy)
				{
					old_sdy = sdy;
                                        if (sdy != 0)
                                        	index--;
				}
					plot(px,py,color);
					x_coord[index] = px;
					y_coord[index] = py;
					index++;
			}
		}
        }
        index--;
	if (sy0 + sdy == 0)
		index--;
	sort(index,x_coord,y_coord);
	toggle = 0;
	for (i=0; i<index; i++)
	{
		if ((y_coord[i] == y_coord[i+1]) &&
			(toggle == 0))
		{
			for (j=x_coord[i]; j<=x_coord[i+1];
				 j++)
				plot(j,y_coord[i],color);
			toggle = 1;
		}
		else
			toggle = 0;
	}
	free(x_coord);
	free(y_coord);
	free(n_point);
}
