               /*Ŀ
                                                                        
                   fillOval() = draws an oval centered at (x,y) with    
                                radius in y direction of 'b' with       
                                aspect ratio 'aspect' and fills it      
                                with color 'color'.                     
                                                                        
                 */

#include "gdraws.h"


void fillOval(int x, int y, int b, int color, float aspect)
{
	#include <dos.h>

	union REGS reg;

	#define seq_out(index,val)  {outp(0x3C4,index);\
					 outp(0x3C5,val);}
	#define graph_out(index,val)  {outp(0x3CE,index);\
					 outp(0x3CF,val);}

	unsigned int offset;
	char far * mem_address;
	int col, col1, row, row1, dummy, i, mask;
        float aspect_square;
	long a_square, b_square, two_a_square, two_b_square, four_a_square,
             four_b_square,d;


	char far *base;

	aspect_square = aspect*aspect;
	a_square = b*b/aspect_square;

	#ifdef CGA
	a_square >>= 2;
	b = (53*b) >> 7;
	#endif

	#ifdef EGA
	b = (93*b) >> 7;
	#endif

	b_square = b*b;
	row = b;
	col = 0;
	convert(x,y);
	two_a_square = a_square << 1;
	four_a_square = a_square << 2;
	four_b_square = b_square << 2;
	two_b_square = b_square << 1;
	d = two_a_square * ((row  -1)*(row )) + a_square +
	    two_b_square*(1-a_square);
	while (a_square*(row ) > b_square * (col))
	{
		for (i=y-row; i<=y+row; i++)
		{
			#ifdef CGA
			plot(x+col,i,color);
			plot(x-col,i,color);
			#endif

			#ifndef CGA
			offset = (long)i * 80L + ((long)(x + col) / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			mask = 0x80 >> ((x + col) % 8);
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			offset = (long)i * 80L + ((long)(x - col) / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			mask = 0x80 >> ((x - col) % 8);
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			seq_out(2,0x0F);
			graph_out(3,0);
			graph_out(8,0xFF);
			#endif
		}
		if (d>= 0)
		{
			row--;
			d -= four_a_square*(row);
		}
		d += two_b_square*(3 + (col << 1));
		col++;
	}

	d = two_b_square * (col + 1)*col + two_a_square*(row *
                (row  -2) +1) + (1-two_a_square)*b_square;
	while ((row) + 1)
	{
		for (i=y-row; i<=y+row; i++)
		{
			#ifdef CGA
			plot(x+col,i,color);
			plot(x-col,i,color);
			#endif

			#ifndef CGA
			offset = (long)i * 80L + ((long)(x + col) / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			mask = 0x80 >> ((x + col) % 8);
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			offset = (long)i * 80L + ((long)(x - col) / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			mask = 0x80 >> ((x - col) % 8);
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			seq_out(2,0x0F);
			graph_out(3,0);
			graph_out(8,0xFF);
			#endif
		}
		if (d<= 0)
		{
			col++;
			d += four_b_square*col;
		}
		row--;
		d += two_a_square * (3 - (row <<1));
	}
}
