               /*Ŀ
                                                                        
                  fillPoly() = fills a polygon in specified color by    
                               filling in boundaries resulting from     
                               connecting specified points in the       
                               order given and then connecting last     
                               point to first.                          
                                                                        
                 */

#include "gdraws.h"
void fillPoly(int color,...)
{
	#include <dos.h>
	#include <stdarg.h>
	#include <stdio.h>

	#define sign(x) ((x) > 0 ? 1:  ((x) == 0 ? 0:  (-1)))

	int dx, dy, dxabs, dyabs, i, index=0, j, k, px, py, sdx, sdy, x, y,
        	xpoint[150], ypoint[150], toggle,
        	old_sdy,sy0;
        long int check;
	int *x_coord, *y_coord;

        va_list coord;

	x_coord = (int *) malloc(4000 * sizeof(int));
	y_coord = (int *) malloc(4000 * sizeof(int));
	va_start(coord,color);
	for (i=0; i<150; i++)
	{
		xpoint[i] = va_arg(coord,int);
		ypoint[i] = va_arg(coord,int);
        	convert(xpoint[i], ypoint[i]);
		if ((xpoint[i] < 0) || (ypoint[i] > 480))
			break;
	}
	va_end(coord);
	xpoint[i] = xpoint[0];
	ypoint[i] = ypoint[0];
	if (i<3) return;
	px = xpoint[0];
	py = ypoint[0];
	if (ypoint[1] == ypoint[0])
	{
		x_coord[index] = px;
		y_coord[index++] = py;
	}
	for (j=0; j<i; j++)
	{
		dx = xpoint[j+1] - xpoint[j];
		dy = ypoint[j+1] - ypoint[j];
		sdx = sign(dx);
		sdy = sign(dy);
		if (j==0)
		{
			old_sdy = sdy;
			sy0 = sdy;
		}
		dxabs = abs(dx);
		dyabs = abs(dy);
		x = 0;
		y = 0;
		if (dxabs >= dyabs)
		{
			for (k=0; k<dxabs; k++)
			{
				y += dyabs;
				if (y>=dxabs)
				{
					y -= dxabs;
					py += sdy;
					if (old_sdy != sdy)
					{
						old_sdy = sdy;
						index--;
					}
					x_coord[index] = px+sdx;
					y_coord[index++] = py;
				}
				px += sdx;
				pattern_plot(px,py,color);
			}
		}
		else
		{
			for (k=0; k<dyabs; k++)
			{
				x += dxabs;
				if (x>=dyabs)
				{
					x -= dyabs;
					px += sdx;
        			}
				py += sdy;
				if (old_sdy != sdy)
				{
					old_sdy = sdy;
					if (sdy != 0)
						index--;
				}

				pattern_plot(px,py,color);
				x_coord[index] = px;
				y_coord[index++] = py;
			}
		}
        }
	index--;
	if (sy0 + sdy== 0)
		index--;
	sort(index,x_coord,y_coord);
	toggle = 0;
	for (i=0; i<index; i++)
	{
		if ((y_coord[i] == y_coord[i+1]) &&
			(toggle == 0))
		{
			for (j=x_coord[i]; j<=x_coord[i+1];
				 j++)
				pattern_plot(j,y_coord[i],color);
			toggle = 1;
		}
		else
			toggle = 0;
	}

	free(x_coord);
	free(y_coord);
}
