               /*Ŀ
                                                                        
                    plot() = plots a point to the screen at designated  
                             location in screen coordinates in selected 
                             color.                                     
                                                                        
                 */

#include "gdraws.h"

void plot(int x, int y, int color)
{
	unsigned int offset;
        int page;
        char mask;
        char far *address;

        page = getPage();
        offset = 0x2000 * (y%4) + 0x8000 * page + 90 * (y/4) + x/8;
	mask = 0x80 >> (x%8);
        address = (char far *)0xB0000000L + offset;
        if (color == 1)
    		*address |= mask;
	else
        	*address &= ~mask;
}
